/******************************************************************************\
 *           ___        __                                                    *
 *          /\_ \    __/\ \                                                   *
 *          \//\ \  /\_\ \ \____    ___   _____   _____      __               *
 *            \ \ \ \/\ \ \ '__`\  /'___\/\ '__`\/\ '__`\  /'__`\             *
 *             \_\ \_\ \ \ \ \L\ \/\ \__/\ \ \L\ \ \ \L\ \/\ \L\.\_           *
 *             /\____\\ \_\ \_,__/\ \____\\ \ ,__/\ \ ,__/\ \__/.\_\          *
 *             \/____/ \/_/\/___/  \/____/ \ \ \/  \ \ \/  \/__/\/_/          *
 *                                          \ \_\   \ \_\                     *
 *                                           \/_/    \/_/                     *
 *                                                                            *
 * Copyright (C) 2011 - 2014                                                  *
 * Dominik Charousset <dominik.charousset (at) haw-hamburg.de>                *
 *                                                                            *
 * Distributed under the Boost Software License, Version 1.0. See             *
 * accompanying file LICENSE or copy at http://www.boost.org/LICENSE_1_0.txt  *
\******************************************************************************/


#ifndef CPPA_IO_STREAM_HPP
#define CPPA_IO_STREAM_HPP

#include "cppa/io/input_stream.hpp"
#include "cppa/io/output_stream.hpp"

namespace cppa {
namespace io {

/**
 * @brief A stream capable of both reading and writing.
 */
class stream : public input_stream, public output_stream {

 public:

    ~stream();

};

/**
 * @brief An IO stream pointer.
 */
typedef intrusive_ptr<stream> stream_ptr;

} // namespace io
} // namespace cppa

#endif // CPPA_IO_STREAM_HPP
