/******************************************************************************\
 *           ___        __                                                    *
 *          /\_ \    __/\ \                                                   *
 *          \//\ \  /\_\ \ \____    ___   _____   _____      __               *
 *            \ \ \ \/\ \ \ '__`\  /'___\/\ '__`\/\ '__`\  /'__`\             *
 *             \_\ \_\ \ \ \ \L\ \/\ \__/\ \ \L\ \ \ \L\ \/\ \L\.\_           *
 *             /\____\\ \_\ \_,__/\ \____\\ \ ,__/\ \ ,__/\ \__/.\_\          *
 *             \/____/ \/_/\/___/  \/____/ \ \ \/  \ \ \/  \/__/\/_/          *
 *                                          \ \_\   \ \_\                     *
 *                                           \/_/    \/_/                     *
 *                                                                            *
 * Copyright (C) 2011 - 2014                                                  *
 * Dominik Charousset <dominik.charousset (at) haw-hamburg.de>                *
 *                                                                            *
 * Distributed under the Boost Software License, Version 1.0. See             *
 * accompanying file LICENSE or copy at http://www.boost.org/LICENSE_1_0.txt  *
\******************************************************************************/


#ifndef CPPA_UTIL_TBIND_HPP
#define CPPA_UTIL_TBIND_HPP

namespace cppa {
namespace util {

/**
 * @ingroup MetaProgramming
 * @brief Predefines the first template parameter of @p Tp1.
 */
template<template<typename, typename> class Tpl, typename Arg1>
struct tbind {
    template<typename Arg2>
    struct type {
        static constexpr bool value = Tpl<Arg1, Arg2>::value;
    };
};

} // namespace util
} // namespace cppa


#endif // CPPA_UTIL_TBIND_HPP
